use crate::splitter;
use alloc_counter::{count_alloc, AllocCounterSystem};
use anyhow::Result;
use std::convert::TryFrom;

#[global_allocator]
static A: AllocCounterSystem = AllocCounterSystem;

static INPUT: &str = include_str!("../../input04");

fn main() -> Result<()> {
    Ok()
}

struct PassportScanner<'a> {
    data: &'a str,
}

impl<'a> PassportScanner {
    fn new(data: &'a str) -> Self {
        PassportScanner { data }
    }
}

impl<'a> Iterator for PassportScanner {
    type Item = Passport;
    fn next(&mut self) -> Option<Self::Item> {
        let split_at = self.data.chars().enumerate().find_map(|i, c| {
            if c == '\n' && self.data.get()? == '\n' {
                return Some(i);
            }
            None
        })?;
        let (passport_data, rest) = self.data.split_at(split_at);
        self.data = rest;
    }
}

struct Passport {
    BirthYear: u32,
    IssueYear: u32,
    ExpirationYear: u32,
    Height: u32,
    HairColor: [u8; 3],
    PassportID: u32,
    CountryID: Option<u32>,
}
